/*
   Copyright (c) 2009-2016, Jack Poulson
   All rights reserved.

   This file is part of Elemental and is under the BSD 2-Clause License,
   which can be found in the LICENSE file in the root directory, or at
   http://opensource.org/licenses/BSD-2-Clause
*/

/* NOTE: This is a commonly-used hack that is only included in this file to
         help avoid redundancy. */
#define INNER_IF_GUARD_AND_PAYLOAD(CDIST,RDIST,WRAP) \
  if( INNER_GUARD(CDIST,RDIST,WRAP) ) { INNER_PAYLOAD(CDIST,RDIST,WRAP) }

#define INNER_ELSEIF_GUARD_AND_PAYLOAD(CDIST,RDIST,WRAP) \
  else INNER_IF_GUARD_AND_PAYLOAD(CDIST,RDIST,WRAP)

#define IF_GUARD_AND_PAYLOAD(CDIST,RDIST,WRAP) \
  if( GUARD(CDIST,RDIST,WRAP) ) \
  { \
      PAYLOAD(CDIST,RDIST,WRAP) \
      INNER_IF_GUARD_AND_PAYLOAD(    CIRC,CIRC,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MC,  MR  ,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MC,  STAR,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MD,  STAR,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MR,  MC  ,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MR,  STAR,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,MC  ,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,MD  ,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,MR  ,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,STAR,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,VC  ,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,VR  ,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(VC,  STAR,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(VR,  STAR,ELEMENT) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(CIRC,CIRC,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MC,  MR  ,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MC,  STAR,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MD,  STAR,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MR,  MC  ,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(MR,  STAR,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,MC  ,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,MD  ,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,MR  ,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,STAR,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,VC  ,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(STAR,VR  ,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(VC,  STAR,BLOCK) \
      INNER_ELSEIF_GUARD_AND_PAYLOAD(VR,  STAR,BLOCK) \
  }

#define ELSEIF_GUARD_AND_PAYLOAD(CDIST,RDIST,WRAP) \
  else IF_GUARD_AND_PAYLOAD(CDIST,RDIST,WRAP)

IF_GUARD_AND_PAYLOAD(    CIRC,CIRC,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(MC,  MR  ,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(MC,  STAR,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(MD,  STAR,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(MR,  MC  ,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(MR,  STAR,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(STAR,MC  ,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(STAR,MD  ,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(STAR,MR  ,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(STAR,STAR,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(STAR,VC  ,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(STAR,VR  ,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(VC,  STAR,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(VR,  STAR,ELEMENT)
ELSEIF_GUARD_AND_PAYLOAD(CIRC,CIRC,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(MC,  MR  ,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(MC,  STAR,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(MD,  STAR,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(MR,  MC  ,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(MR,  STAR,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(STAR,MC  ,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(STAR,MD  ,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(STAR,MR  ,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(STAR,STAR,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(STAR,VC  ,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(STAR,VR  ,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(VC,  STAR,BLOCK)
ELSEIF_GUARD_AND_PAYLOAD(VR,  STAR,BLOCK)

#undef ELSEIF_GUARD_AND_PAYLOAD
#undef IF_GUARD_AND_PAYLOAD
#undef INNER_PAYLOAD
#undef INNER_GUARD
#undef GUARD
#undef PAYLOAD
